=== debian/control ===
Source: tlp
Maintainer: Raphaël Halimi <raphael.halimi@gmail.com>
Section: utils
Priority: optional
Build-Depends: debhelper-compat (= 13), dh-python, python3
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/moonsweep/tlp
Vcs-Git: https://salsa.debian.org/moonsweep/tlp.git
Homepage: https://linrunner.de/tlp

Package: tlp
Architecture: all
Depends: hdparm, iw, pciutils, rfkill, usbutils, ${misc:Depends}
Recommends: tlp-rdw, ethtool
Suggests: tlp-pd, tp-smapi-dkms, smartmontools, ${dist:Suggests}
Conflicts: laptop-mode-tools, power-profiles-daemon, tuned
Description: Optimize laptop battery life
 TLP is a feature-rich command-line utility, saving laptop battery power
 without the need to delve deeper into technical details.
 .
 TLP’s default settings are already optimized for battery life and implement
 Powertop’s recommendations out of the box. Moreover TLP is highly
 customizable to fulfil specific user requirements.
 .
 Settings are organized into the three customizable profiles performance (AC),
 balanced (BAT) and power-saver (SAV), allowing to adjust between savings
 and performance independently for battery and AC operation.
 .
 In addition TLP can enable or disable bluetooth, NFC, Wi-Fi and WWAN
 devices on boot.
 .
 For ThinkPads and many other laptop brands it provides a unified way to
 configure charge thresholds and recalibrate the battery.

Package: tlp-rdw
Architecture: all
Depends: network-manager, tlp, ${misc:Depends}
Description: Switch Wi-Fi and Bluetooth on/off automatically
 Radio device wizard is an add-on to TLP. It provides automated
 switching of Bluetooth, NFC, Wi-Fi and WWAN radio devices when:
  - a LAN cable is connected or removed
  - the laptop is docked or undocked

Package: tlp-pd
Architecture: all
Depends: tlp, polkitd, python3-dbus, python3-gi, ${misc:Depends}, ${python3:Depends}
Conflicts: power-profiles-daemon, tuned-ppd
Description: Switch Power Profiles from the Desktop
 TLP Profiles Daemon (tlp-pd) is an add-on to TLP. It implements the D-Bus
 interface, which lets desktop environments show a power profile switch.
 Together with TLP as the backend for applying the customizable profiles,
 it replaces power-profiles-daemon.
