=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# Override Makefile defaults
export TLP_ZSHCPL=/usr/share/zsh/vendor-completions

%:
	dh $@ --with python3

override_dh_installsystemd:
	dh_installsystemd --package=tlp --no-start --no-restart-after-upgrade
	dh_installsystemd --package=tlp-pd

override_dh_installinit:
	dh_installinit --package=tlp --no-start --no-restart-after-upgrade --only-scripts -- defaults 98 01

override_dh_gencontrol:
	dh_gencontrol --package=tlp -- $(SUBSTVARS)
	dh_gencontrol --remaining-packages

override_dh_installdocs:
	dh_installdocs --link-doc tlp
