## tlp 1.9.0

=== debian/changelog ===
tlp (1.9.0-1) unstable; urgency=medium

  * New upstream version 1.9.0

  [ Thomas Koch ]
  * [f0dda7f] New sub-package tlp-pd
  * [d61dd38] Drop lintian overrides
  * [28c22dd] Update descriptions
  * [04501e0] Cleanup copyright
  * [664933c] Refactor dependencies

  [ Raphaël Halimi ]
  * [06f3307] debian/watch: update to v5 format
  * [aa2e2eb] Bump Standards-Version to 4.7.2

 -- Raphaël Halimi <raphael.halimi@gmail.com>  Wed, 24 Dec 2025 19:56:18 +0100
