## tlp 1.9.1

=== Makefile ===
--- 
+++ 
@@ -347,8 +347,9 @@
 	rm -f $(_FISHCPL)/tlp-rdw.fish
 
 uninstall-pd:
-	rm -f $(_SBIN)/tlp-pd
-	rm -f $(_BIN)/tlpctl
+	rm $(_SBIN)/tlp-pd
+	rm $(_BIN)/tlpctl
+	rm -f $(_SYSD)/tlp-pd.service
 	rm -f $(_POLKIT)/tlp-pd.policy
 	rm -f $(_DBCONF)/org.freedesktop.UPower.PowerProfiles.conf
 	rm -f $(_DBSVC)/org.freedesktop.UPower.PowerProfiles.service
@@ -376,7 +377,7 @@
 
 uninstall-man: uninstall-man-tlp uninstall-man-rdw uninstall-man-pd
 
-checkall: checkbashisms shellcheck perlcritic checkdupconst checkbatdrv checkwip
+checkall: checkbashisms shellcheck perlcritic checkdupconst checkman checkbatdrv checkwip
 
 checkbashisms:
 	@echo "*** checkbashisms ***************************************************************************"
@@ -394,8 +395,9 @@
 	@echo "*** checkdupconst ***************************************************************************"
 	@{ sed -n -r -e 's,^.*readonly\s+([A-Za-z_][A-Za-z_0-9]*)=.*$$,\1,p' $(SHFILES) | sort | uniq -d; } || true
 
+checkman:
+	@echo "*** checkman ********************************************************************************"
+	@grep '.TH ' man/* man-pd/* man-rdw/*
+
 checkwip:
 	@echo "*** checkwip ********************************************************************************"
-	@grep -E -n "### (DEBUG|DEVEL|TODO|WIP)" $(SHFILES) $(UTSHFILES) $(PLFILES) $(PYFILES) || true
-
-bat.d/TEMPLATE~: bat.d/TEMPLATE
