=== debian/changelog ===
tlp (1.9.1-1~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Raphaël Halimi <raphael.halimi@gmail.com>  Wed, 07 Jan 2026 21:13:42 +0100

tlp (1.9.1-1) unstable; urgency=medium

  * [37010cb] New upstream version 1.9.1
  * [27f17fc] debian/copyright: update copyright years

 -- Raphaël Halimi <raphael.halimi@gmail.com>  Wed, 07 Jan 2026 21:09:54 +0100
