=== debian/watch ===
# Watch file for TLP
Version: 5
Template: Github
Owner: linrunner
Project: TLP
